#pragma once
#include "SimpleStroke.h"
#include "tendes_plane.h"
#include <list>

using namespace std;

typedef struct VisibleMeshInfo {
	Polyhedron *mesh;
	int num_visible_triangles;
	int *visible_tri_idx;
	float *visible_tri_vertex_coords;
	float *visible_tri_vertex_tex_coords[8];

	VisibleMeshInfo() {
		mesh = NULL;
		num_visible_triangles = 0;
		visible_tri_idx = NULL;
		visible_tri_vertex_coords = NULL;

		for(int i = 0; i < 8; i++) {
			visible_tri_vertex_tex_coords[i] = NULL;
		}
	}

} VisibleMeshInfo;


typedef struct ImageCompositionInfo {
	int image_composition_method;
	bool copy_back;
	int coords[4];
	int num_enabled_warped_images;
	float *blend_map;

	ImageCompositionInfo() {
		image_composition_method = 0;
		copy_back = false;
		blend_map = NULL;

		for(int i = 0; i < 4; i++) {
			coords[i] = 0;
		}

		num_enabled_warped_images = 0;
	}

} ImageCompositionInfo;


typedef struct IBFV_SimpleLayer {
	IBFV_SimpleLayer(int width, int height);
	~IBFV_SimpleLayer();

	unsigned char *rendered_image;
	unsigned char *initial_stroke_image;
	list<SimpleStroke*> strokes;

} IBFV_SimpleLayer;

