

// empty class.
class IPaintingParam {};


class IPaintRenderer {
protected:
	int width;
	int height;

public:
	// create a renderer with a dimension (width x height)
	IPaintRenderer(int width, int height) {
		if(width <= 0 || height <= 0) {
			throw "IPaintRenderer: Invalid Dimension\r\n";
		}

		this->width = width;
		this->height = height;
	}

	virtual ~IPaintRenderer() {}

	// pass a set of parameters (or data) for rendering. It assumes that all parameters are valid for this renderer
	virtual void setParams(IPaintingParam *param) = 0;

	// render an image with a dimension (width x height)
	virtual bool render(unsigned char *result) = 0;

	// simply return width and height, respectively
	int getWidth() { return width; }
	int getHeight() { return height; }

	// resize
	virtual bool resize(int width, int height) = 0;

	// get rendering time
	virtual double getRenderingTime() = 0;
};
