#pragma once
#include <cv.h>

static const int OF_DEFAULT_WINDOW_SIZE = 10;
static const int OF_DEFAULT_NUM_PYRAMIDS = 5;
static const CvTermCriteria OF_DEFAULT_CRITERIA = cvTermCriteria(CV_TERMCRIT_ITER | CV_TERMCRIT_EPS, 5, 0.01);


class OpticalFlow {
private:
	int capacity;
	int window_size;
	int num_pyramids;
	CvTermCriteria criteria;

public:
	OpticalFlow(
		CvTermCriteria criteria = OF_DEFAULT_CRITERIA, 
		int window_size = OF_DEFAULT_WINDOW_SIZE, 
		int num_pyramids = OF_DEFAULT_NUM_PYRAMIDS
	);

	~OpticalFlow();

	void LK(IplImage *img1, IplImage *img2, CvPoint2D32f *result);
	void LK(IplImage *img1, IplImage *img2, float *result);
	void HS(IplImage *img1, IplImage *img2, CvPoint2D32f *result);
	void HS(IplImage *img1, IplImage *img2, float *result);
	void PyrLK(IplImage *img1, IplImage *img2, CvPoint2D32f *result);
	void PyrLK(IplImage *img1, IplImage *img2, float *result);
};
