#pragma once
#include "stdafx.h"
#include "cv.h"
#include <iostream>
#include <fstream>


using namespace std;


class OpticalFlowReader {
private:
	int w, h;
	int num_frames;		// number of frames
	int direction;		// 1 if forward, 0 if backward
	FILE *optflow;

	int loaded_frame_number;
	CvPoint2D32f *loaded_data;

public:
	OpticalFlowReader();
	~OpticalFlowReader();

	bool read(const TCHAR *filepath);
	void clear();
	int getNumFrames();
	int getWidth();
	int getHeight();
	void getDimension(int &width, int &height);
	int getOpticalFlowDirection();
	bool load(int frame, CvPoint2D32f *data);
	bool load(int frame, float *data);
};
