#pragma once
#include "Resource.h"
#include "MFCTEST4Dlg.h"
#include "VisView.h"



// Forward Declaration
class CMFCTEST4Dlg;


// TabContent0 dialog

class TabContent0 : public CDialog
{
	DECLARE_DYNAMIC(TabContent0)

public:
	TabContent0(CMFCTEST4Dlg* pParent = NULL);
	virtual ~TabContent0();
	void initializeValues();

// Dialog Data
	enum { IDD = IDD_DIALOG0 };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnOK();
	virtual void OnCancel();

	DECLARE_MESSAGE_MAP()

private:
	CMFCTEST4Dlg *parent;

public:
	const static int img_smoothing_for_edgefield_range[2];		// [0, 100]
	const static int init_img_smoothing_for_edgefield_range;	// 5

	const static int edge_field_smoothing_range[2];		// [0, 500]
	const static int init_edge_field_smoothing_val;		// 50

	const static int global_rotation_range[2];					// [0, 360]
	const static int init_global_rotation_val;					// 0

	const static double weight_interpolation_range[2];		// [0, 1]
	const static double init_weight_interpolation;			// 0.5;
	const static int weight_interpolation_prec = 2;



	void updateRegionOption();


public:
	// field design options
	afx_msg void OnEnKillfocusEdgeFieldSmoothing();
	afx_msg void OnDeltaposEdgeFieldSmoothingSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnDeltaposGlobalRotationSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusGlobalRotation();
	afx_msg void OnBnClickedAddRegularElement();
	afx_msg void OnBnClickedAddSource();
	afx_msg void OnBnClickedAddSink();
	afx_msg void OnBnClickedAddCcwCenter();
	afx_msg void OnBnClickedAddCwCenter();
	afx_msg void OnBnClickedAddSaddle();
	afx_msg void OnBnClickedAddDipole1();
	afx_msg void OnBnClickedAddDipole2();
	afx_msg void OnBnClickedAddMonkeySaddle();
	afx_msg void OnBnClickedEditElement();
	afx_msg void OnBnClickedRemoveElement();
	afx_msg void OnBnClickedFlowSmoothing();		// <-- ???
	afx_msg void OnBnClickedSingularityPairCancellation();
	afx_msg void OnBnClickedMoveSingularity();
	afx_msg void OnBnClickedSetZero();
	afx_msg void OnBnClickedComputeEdgeFieldFromImage();
	afx_msg void OnBnClickedGlobalReflection();
	afx_msg void OnBnClickedCloseRegion();
	afx_msg void OnBnClickedClearRegion();
	afx_msg void OnEnKillfocusWeightInterpolation();
	afx_msg void OnDeltaposWeightInterpolationSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusImgSmoothEdgefield();
	afx_msg void OnDeltaposImgSmoothEdgefieldSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnEnKillfocusStrongVertexRatio();
	afx_msg void OnDeltaposStrongVertexRatioSpin(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnBnClickedZerofield();
	afx_msg void OnBnClickedHeatdiffusion();
	afx_msg void OnBnClickedUseInitialField();
	afx_msg void OnBnClickedApplyTransformation();
};
