// TabContent1.cpp : implementation file
//

#pragma once
#include "stdafx.h"
#include "TabContent1.h"
#include "StrokeParams.h"
#include "PathMaker.h"
#include "RGBOptionDlg.h"
#include "HSVOptionDlg.h"
#include ".\tabcontent1.h"

using namespace std;

extern float stepsize;	// refer to VisView.cpp...


// TabContent1 dialog

IMPLEMENT_DYNAMIC(TabContent1, CDialog)


TabContent1::TabContent1(CMFCTEST4Dlg* pParent)
	: CDialog(TabContent1::IDD, pParent)
{
	ASSERT(pParent != NULL);
	Create(IDD, pParent);
	this->parent = pParent;
	initializeValues();
}


LPCTSTR TabContent1::color_composition_methods[] = {
	_T("Alpha Blend"), 
	_T("Overwrite"), 
};


LPCTSTR TabContent1::NPN_type[] = {
	_T("128"), 
	_T("256"), 
};


LPCTSTR TabContent1::noise_type[] = {
	_T("Method 0"), 
	_T("Method 1"), 
};


LPCTSTR TabContent1::post_processing_operation[] = {
	_T("Watercolor Effect"), 
	_T("Embossing"), 
};


LPCTSTR TabContent1::tensor_vis_type[] = {
	_T("Major"), 
	_T("Minor"), 
	_T("Major & Minor"), 
};


LPCTSTR TabContent1::display_mode[] = {
	_T("Edge Field (Vector)"), 
	_T("Edge Field (Tensor)"), 
	_T("Painting"), 
	_T("Input Image"), 
	_T("Black"), 
	_T("Blend Map"), 
	_T("Segmentation"),
	_T("Label File"),
	_T("Stroke Ref. Image"),
};


LPCTSTR TabContent1::ten_img_composition_methods[] = {
	_T("V+x, V-x, V+y, V-y, all independent"), 
	_T("V+x, V-x, V+y, V-y, all shared"), 
	_T("V+x, V+y, independent"), 
	_T("V+x, V+y, shared"), 
	_T("V+x, V-x, independent"), 
	_T("V+x, V-x, shared"), 
	_T("V+x"), 
	_T("V-x"), 
	_T("V+y"), 
	_T("V-y"), 
	_T("V+y, V-y, independent"), 
	_T("V-x, V-y, independent"), 
};


LPCTSTR TabContent1::vec_img_composition_methods[] = {
	_T("One direction"), 
	_T("Two directions"), 
};


LPCTSTR TabContent1::sorting_options[] = {
	_T("Sort only new strokes, then append"), 
	_T("Sort a whole set of strokes"), 
};


LPCTSTR TabContent1::style_interpolations[] = {
	_T("Undefined"), 
	_T("Linear"), 
	_T("Fade Slow"), 
	_T("Fade Slower"), 
	_T("Fade Fast"), 
	_T("Fade Faster"), 
	_T("Ease In/Out"), 
};


TabContent1::~TabContent1()
{

	if(option_dlg != NULL) {
		option_dlg->DestroyWindow();
		delete option_dlg;
		option_dlg = NULL;
	}
}

void TabContent1::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(TabContent1, CDialog)
	ON_CBN_SELCHANGE(IDC_DISPLAY_MODE, OnCbnSelchangeDisplayMode)
	ON_CBN_SELCHANGE(IDC_TENSOR_VIS_MODE, OnCbnSelchangeTensorVisMode)
	ON_CBN_SELCHANGE(IDC_IMAGE_COMPOSITION_METHOD, OnCbnSelchangeImageCompositionMethod)
	ON_CBN_SELCHANGE(IDC_COLOR_COMPOSITION_METHOD, OnCbnSelchangeColorCompositionMethod)
	ON_CBN_SELCHANGE(IDC_NPN, OnCbnSelchangeNpn)
	ON_EN_KILLFOCUS(IDC_DISPLACEMENT, OnEnKillfocusDisplacement)
	ON_NOTIFY(UDN_DELTAPOS, IDC_DISPLACEMENT_SPIN, OnDeltaposDisplacementSpin)
	ON_EN_KILLFOCUS(IDC_BGIMG_BLEND, OnEnKillfocusBgImgBlend)
	ON_NOTIFY(UDN_DELTAPOS, IDC_BGIMG_BLEND_SPIN, OnDeltaposBgImgBlendSpin)
	ON_EN_KILLFOCUS(IDC_WARP_ITERATION, &TabContent1::OnEnKillfocusNumIterations)
	ON_NOTIFY(UDN_DELTAPOS, IDC_WARP_ITERATION_SPIN, &TabContent1::OnDeltaposNumIterationsSpin)
	ON_BN_CLICKED(IDC_RENDER_IBFV, &TabContent1::OnBnClickedSelectRenderer)
	ON_BN_CLICKED(IDC_RENDER_SPLINE, &TabContent1::OnBnClickedSelectRenderer)
	ON_NOTIFY(UDN_DELTAPOS, IDC_NOISE_AMPLITUDE_SPIN, OnDeltaposNoiseAmplitudeSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_DISPLACEMENT_SPIN, OnDeltaposStrokeDisplacementSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_MINLENGTH_SPIN, OnDeltaposStrokeMinLengthSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_MAXLENGTH_SPIN, OnDeltaposStrokeMaxLengthSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_PARAM1_SPIN, OnDeltaposStrokeParam1Spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_AMOUNT_SPIN, OnDeltaposStrokeAmountSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_POSITION_JITTER_SPIN, OnDeltaposStrokePositionJitterSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_NUM_LAYERS_SPIN, OnDeltaposNumLayersSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_AREA_ERROR_SPIN, OnDeltaposAreaError)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_OPACITY_SPIN, OnDeltaposStrokeOpacitySpin)
	ON_EN_KILLFOCUS(IDC_NOISE_AMPLITUDE, OnEnKillfocusNoiseAmplitude)
	ON_EN_KILLFOCUS(IDC_STROKE_DISPLACEMENT, OnEnKillfocusStrokeDisplacement)
	ON_EN_KILLFOCUS(IDC_STROKE_MINLENGTH, OnEnKillfocusStrokeMinLength)
	ON_EN_KILLFOCUS(IDC_STROKE_MAXLENGTH, OnEnKillfocusStrokeMaxLength)
	ON_EN_KILLFOCUS(IDC_STROKE_PARAM1, OnEnKillfocusStrokeParam1)
	ON_EN_KILLFOCUS(IDC_STROKE_AMOUNT, OnEnKillfocusStrokeAmount)
	ON_EN_KILLFOCUS(IDC_STROKE_POSITION_JITTER, OnEnKillfocusStrokePositionJitter)
	ON_EN_KILLFOCUS(IDC_NUM_LAYERS, OnEnKillfocusNumLayers)
	ON_EN_KILLFOCUS(IDC_AREA_ERROR, OnEnKillfocusAreaError)
	ON_EN_KILLFOCUS(IDC_STROKE_OPACITY, OnEnKillfocusStrokeOpacity)
	ON_EN_KILLFOCUS(IDC_POST_PROCESS_PARAM1, OnEnKillfocusPostProcessParam1)
	ON_EN_KILLFOCUS(IDC_POST_PROCESS_PARAM2, OnEnKillfocusPostProcessParam2)
	ON_EN_KILLFOCUS(IDC_POST_PROCESS_PARAM3, OnEnKillfocusPostProcessParam3)
	ON_EN_KILLFOCUS(IDC_POST_PROCESS_PARAM4, OnEnKillfocusPostProcessParam4)
	ON_NOTIFY(UDN_DELTAPOS, IDC_POST_PROCESS_PARAM1_SPIN, OnDeltaposPostProcessParam1Spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_POST_PROCESS_PARAM2_SPIN, OnDeltaposPostProcessParam2Spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_POST_PROCESS_PARAM3_SPIN, OnDeltaposPostProcessParam3Spin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_POST_PROCESS_PARAM4_SPIN, OnDeltaposPostProcessParam4Spin)
	ON_CBN_SELCHANGE(IDC_POST_PROCESSING_OPERATION, OnCbnSelchangePostProcessingOperation)
	ON_BN_CLICKED(IDC_SET_PRESET, &TabContent1::OnBnClickedSetPreset)
	ON_BN_CLICKED(IDC_REMOVE_PRESET, &TabContent1::OnBnClickedRemovePreset)
	ON_BN_CLICKED(IDC_RESET_PAINTING, OnBnClickedResetPainting)
	ON_BN_CLICKED(IDC_PRESET_WATERCOLOR, OnBnClickedPresetWatercolor)
	ON_BN_CLICKED(IDC_PRESET_POINTILLISM, OnBnClickedPresetPointillism)
	ON_BN_CLICKED(IDC_PRESET_FRACTURE2, OnBnClickedPresetFracture2)
	ON_BN_CLICKED(IDC_PRESET_VANGOGH_SP, OnBnClickedPresetVangoghSP)
	ON_BN_CLICKED(IDC_PRESET_IMPRESSIONISM_SP, OnBnClickedPresetImpressionismSP)
	ON_BN_CLICKED(IDC_PRESET_COLORWASH_SP, OnBnClickedPresetColorwashSP)
	ON_BN_CLICKED(IDC_ENABLE_POST_PROCESSING, &TabContent1::OnBnClickedEnablePostProcessing)
	ON_BN_CLICKED(IDC_STROKE_ORDER_1, &TabContent1::OnBnClickedSelectStrokeOrder)
	ON_BN_CLICKED(IDC_STROKE_ORDER_2, &TabContent1::OnBnClickedSelectStrokeOrder)
	ON_BN_CLICKED(IDC_STROKE_ORDER_3, &TabContent1::OnBnClickedSelectStrokeOrder)
	ON_BN_CLICKED(IDC_EMBOSSING_0, &TabContent1::OnBnClickedSelectEmbossingType)
	ON_BN_CLICKED(IDC_EMBOSSING_1, &TabContent1::OnBnClickedSelectEmbossingType)
	ON_BN_CLICKED(IDC_TRACE_CIRCLE, &TabContent1::OnBnClickedSelectTraceMode)
	ON_BN_CLICKED(IDC_TRACE_FREEFORM, &TabContent1::OnBnClickedSelectTraceMode)
	ON_BN_CLICKED(IDC_TRACE_SQUARE, &TabContent1::OnBnClickedSelectTraceMode)
	ON_BN_CLICKED(IDC_TRACE_LINE, &TabContent1::OnBnClickedSelectTraceMode)
	ON_BN_CLICKED(IDC_SHOW_CURVES, OnBnClickedShowCurves)
	ON_EN_KILLFOCUS(IDC_TEST_EDIT, &TabContent1::OnEnKillfocusTestEdit)
	ON_NOTIFY(UDN_DELTAPOS, IDC_TEST_EDIT_SPIN, &TabContent1::OnDeltaposTestEditSpin)
	ON_EN_KILLFOCUS(IDC_GAP_THRESHOLD, &TabContent1::OnEnKillfocusGapThreshold)
	ON_NOTIFY(UDN_DELTAPOS, IDC_GAP_THRESHOLD_SPIN, &TabContent1::OnDeltaposGapThresholdSpin)
	ON_BN_CLICKED(IDC_COLOR_ORDER_OPTION, &TabContent1::OnBnClickedColorOrderOption)
	ON_CBN_SELCHANGE(IDC_SORTING_OPTION, &TabContent1::OnCbnSelchangeSortingOption)
	ON_EN_KILLFOCUS(IDC_STROKE_AMBIENT_H, &TabContent1::OnEnKillfocusStrokeAmbientH)
	ON_EN_KILLFOCUS(IDC_STROKE_AMBIENT_S, &TabContent1::OnEnKillfocusStrokeAmbientS)
	ON_EN_KILLFOCUS(IDC_STROKE_AMBIENT_V, &TabContent1::OnEnKillfocusStrokeAmbientV)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_AMBIENT_H_SPIN, &TabContent1::OnDeltaposStrokeAmbientHSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_AMBIENT_S_SPIN, &TabContent1::OnDeltaposStrokeAmbientSSpin)
	ON_NOTIFY(UDN_DELTAPOS, IDC_STROKE_AMBIENT_V_SPIN, &TabContent1::OnDeltaposStrokeAmbientVSpin)
	ON_CBN_SELCHANGE(IDC_STYLE_INTERPOLATION_SELECTION_COMBO, &TabContent1::OnCbnSelchangeStyleInterpolationSelectionCombo)
	ON_COMMAND(ID_ShowInput, &TabContent1::OnShowinput)
	ON_COMMAND(ID_ShowOPT, &TabContent1::OnShowopt)
	ON_COMMAND(ID_ShowPainting, &TabContent1::OnShowpainting)
	ON_COMMAND(ID_ShowSeg, &TabContent1::OnShowseg)
	ON_COMMAND(ID_ShowTensor, &TabContent1::OnShowtensor)
	ON_COMMAND(ID_ShowVec, &TabContent1::OnShowvec)
END_MESSAGE_MAP()


void TabContent1::OnOK() {}
void TabContent1::OnCancel() {}

void TabContent1::initializeValues() {
	const int num_stroke_order_options = 3;
	const int num_renderer_options = 2;
	const int num_embossing_options = 2;

	int option;
	VisView *visview = parent->getVisView();
	CComboBox* cb;
	CButton **b;
	StrokeParams sp;

	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_DISPLAY_MODE));
	for(int i = 0; i < num_display_mode; i++) cb->AddString(display_mode[i]);

	switch(visview->getDisplayMode()) {
		case VisView::VECTOR_EDGE_FIELD:
		default:
			cb->SetCurSel(0);
			break;

		case VisView::TENSOR_EDGE_FIELD:
			cb->SetCurSel(1);
			break;

		case VisView::PAINTING:
			cb->SetCurSel(2);
			break;

		case VisView::BLACK:
			cb->SetCurSel(3);
			break;

		case VisView::INPUT_IMAGE:
			cb->SetCurSel(4);
			break;

		case VisView::BLENDMAP:
			cb->SetCurSel(5);
			break;
	};


	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_TENSOR_VIS_MODE));
	for(int i = 0; i < num_tensor_vis_type; i++) cb->AddString(tensor_vis_type[i]);

	switch(visview->getTensorVisMode()) {
		case VisView::MAJOR:
		default:
			cb->SetCurSel(0);
			break;

		case VisView::MINOR:
			cb->SetCurSel(1);
			break;

		case VisView::MAJOR_MINOR:
			cb->SetCurSel(2);
			break;
	};


	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));
	for(int i = 0; i < num_ten_img_composition_methods; i++) cb->AddString(ten_img_composition_methods[i]);
	cb->SetCurSel(0);

	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD));
	for(int i = 0; i < num_color_composition_methods; i++) cb->AddString(color_composition_methods[i]);
	cb->SetCurSel(0);

	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_NPN));
	for(int i = 0; i < num_NPN_type; i++) cb->AddString(NPN_type[i]);
	cb->SetCurSel(0);

	updateStyleInterpolationCombo();

	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_POST_PROCESSING_OPERATION));
	for(int i = 0; i < num_post_processing_operations; i++) cb->AddString(post_processing_operation[i]);
	cb->SetCurSel(visview->getPostProcessingOperation());


	selected_vec_composition_method = 0;
	selected_ten_composition_method = 0;


	/*
	visview->setDisplayMode(VisView::TENSOR_EDGE_FIELD);
	visview->setTensorVisMode(VisView::MAJOR);
	visview->setImageSynthesisMethod(0);
	visview->setColorCompositionMethod(VisView::ALPHA_BLEND);
	visview->setNPNSize(128);
	visview->setPostProcessingOperation(0);*/



	//::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getIterations());
	//::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT)), visview->getVisDisplacement(), displacement_prec);
	//::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getBlendAlpha());


	b = new CButton*[num_renderer_options];
	b[0] = reinterpret_cast<CButton*>(GetDlgItem(IDC_RENDER_IBFV));
	b[1] = reinterpret_cast<CButton*>(GetDlgItem(IDC_RENDER_SPLINE));

	for(int i = 0; i < num_renderer_options; i++) {
		b[i]->SetCheck(0);
	}

	option = (int)visview->getRenderingMethod();

	if(0 <= option && option < num_renderer_options) {
		b[option]->SetCheck(1);
	}

	delete[] b;


	sp = visview->getStrokeParams();
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_NOISE_AMPLITUDE)), sp.stroke_color_jitter, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_DISPLACEMENT)), sp.stroke_displacemnt, displacement_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMOUNT)), sp.stroke_gridsize, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_POSITION_JITTER)), sp.stroke_position_jitter, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_PARAM1)), sp.stroke_size, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_OPACITY)), sp.stroke_opacity, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MINLENGTH)), sp.stroke_min_length);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MAXLENGTH)), sp.stroke_max_length);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_H)), sp.stroke_color_shift[0], default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_S)), sp.stroke_color_shift[1], hsv_sv_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_V)), sp.stroke_color_shift[2], hsv_sv_prec);

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_NUM_LAYERS)), visview->getNumEnabledLayers());
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_AREA_ERROR)), visview->getAreaErrorThreshold(), default_prec);



	b = new CButton*[num_stroke_order_options];
	b[0] = reinterpret_cast<CButton*>(GetDlgItem(IDC_STROKE_ORDER_1));
	b[1] = reinterpret_cast<CButton*>(GetDlgItem(IDC_STROKE_ORDER_2));
	b[2] = reinterpret_cast<CButton*>(GetDlgItem(IDC_STROKE_ORDER_3));

	for(int i = 0; i < num_stroke_order_options; i++) {
		b[i]->SetCheck(0);
	}

	option = visview->getStrokeOrder();

	if(0 <= option && option < num_stroke_order_options) {
		b[option]->SetCheck(1);
	}

	delete[] b;

	setStrokeOrderInfoText();


	cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_SORTING_OPTION));
	for(int i = 0; i < 2; i++) cb->AddString(sorting_options[i]);
	cb->SetCurSel((visview->getOrderingRange() == true) ? 0 : 1);


	reinterpret_cast<CButton*>(GetDlgItem(IDC_ENABLE_POST_PROCESSING))->SetCheck(visview->getPostProcessingEnabled() ? 1 : 0);

	switch(visview->getEmbossingType()) {
		case 0:
			reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_0))->SetCheck(1);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_1))->SetCheck(0);
			break;

		case 1:
			reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_0))->SetCheck(0);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_1))->SetCheck(1);
			break;
	}

	GetDlgItem(IDC_POST_PROCESS_PARAM1_CAPTION)->SetWindowText(_T("Edge Darkening:"));
	GetDlgItem(IDC_POST_PROCESS_PARAM2_CAPTION)->SetWindowText(_T("Pigment:"));
	GetDlgItem(IDC_POST_PROCESS_PARAM3_CAPTION)->SetWindowText(_T("Turbulance:"));
	GetDlgItem(IDC_POST_PROCESS_PARAM4_CAPTION)->SetWindowText(_T("Paper Texure:"));

	reinterpret_cast<CComboBox*>(GetDlgItem(IDC_POST_PROCESSING_OPERATION))->SetCurSel(visview->getPostProcessingOperation());
	updatePostProcessingCaptions(visview->getPostProcessingOperation());

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM1)), visview->getPostProcessingParam(0), default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM2)), visview->getPostProcessingParam(1), default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM3)), visview->getPostProcessingParam(2), default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM4)), visview->getPostProcessingParam(3), default_prec);


	switch(visview->getTraceMode()) {
		case PathMaker::FREEFORM:
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_FREEFORM))->SetCheck(1);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_CIRCLE))->SetCheck(0);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_SQUARE))->SetCheck(0);
			break;

		case PathMaker::CIRCLE:
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_FREEFORM))->SetCheck(0);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_CIRCLE))->SetCheck(1);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_SQUARE))->SetCheck(0);
			break;

		case PathMaker::SQUARE:
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_FREEFORM))->SetCheck(0);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_CIRCLE))->SetCheck(0);
			reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_SQUARE))->SetCheck(1);
			break;
	}

	if(visview->getShowCurves() == true) {
		reinterpret_cast<CButton*>(GetDlgItem(IDC_SHOW_CURVES))->SetCheck(1);
	}
	else {
		reinterpret_cast<CButton*>(GetDlgItem(IDC_SHOW_CURVES))->SetCheck(0);
	}


	OnCbnSelchangeDisplayMode();

	option_dlg = NULL;
}


void TabContent1::enableWindowsOnWarpingSetting(int idx) {
	BOOL val;

	if(idx == 1) {
		val = TRUE;
	}
	else {
		val = FALSE;
	}

	GetDlgItem(IDC_TENSOR_VIS_MODE_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_TENSOR_VIS_MODE)->EnableWindow(val);


	if(idx <= 1) {
		val = TRUE;
	}
	else {
		val = FALSE;
	}

	GetDlgItem(IDC_NPN)->EnableWindow(val);
	GetDlgItem(IDC_NPN_CAPTION)->EnableWindow(val);

	GetDlgItem(IDC_DISPLACEMENT_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_DISPLACEMENT)->EnableWindow(val);
	GetDlgItem(IDC_DISPLACEMENT_SPIN)->EnableWindow(val);

	/**
	GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD)->EnableWindow(val);
	/**/

	if(idx == 2) {
		val = TRUE;
	}
	else {
		val = FALSE;
	}

	if(idx <= 2) {
		val = TRUE;
	}
	else {
		val = FALSE;
	}

	GetDlgItem(IDC_WARP_ITERATION_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_WARP_ITERATION)->EnableWindow(val);
	GetDlgItem(IDC_WARP_ITERATION_SPIN)->EnableWindow(val);

	/**/
	GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD)->EnableWindow(val);
	/**/

	if(idx != 2) {
		GetDlgItem(IDC_COLOR_COMPOSITION_METHOD_CAPTION)->EnableWindow(FALSE);
		GetDlgItem(IDC_COLOR_COMPOSITION_METHOD)->EnableWindow(FALSE);
	}
	else {
		GetDlgItem(IDC_COLOR_COMPOSITION_METHOD_CAPTION)->EnableWindow(TRUE);
		GetDlgItem(IDC_COLOR_COMPOSITION_METHOD)->EnableWindow(TRUE);
	}


	if(reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->GetCurSel() != 0) {
		GetDlgItem(IDC_BGIMG_BLEND_CAPTION)->EnableWindow(FALSE);
		GetDlgItem(IDC_BGIMG_BLEND)->EnableWindow(FALSE);
		GetDlgItem(IDC_BGIMG_BLEND_SPIN)->EnableWindow(FALSE);
	}
	else {
		GetDlgItem(IDC_BGIMG_BLEND_CAPTION)->EnableWindow(val);
		GetDlgItem(IDC_BGIMG_BLEND)->EnableWindow(val);
		GetDlgItem(IDC_BGIMG_BLEND_SPIN)->EnableWindow(val);
	}
}


void TabContent1::enableWindowsOnRenderer(BOOL val) {
	GetDlgItem(IDC_RENDER_IBFV)->EnableWindow(val);
	GetDlgItem(IDC_RENDER_SPLINE)->EnableWindow(val);
}


void TabContent1::enableWindowsOnLayering(BOOL val) {
	GetDlgItem(IDC_NUM_LAYERS_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_NUM_LAYERS)->EnableWindow(val);
	GetDlgItem(IDC_NUM_LAYERS_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_AREA_ERROR_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_AREA_ERROR)->EnableWindow(val);
	GetDlgItem(IDC_AREA_ERROR_SPIN)->EnableWindow(val);
}


void TabContent1::enableWindowsOnStrokeOrdering(BOOL val) {
	GetDlgItem(IDC_STROKE_ORDER_1)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_ORDER_2)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_ORDER_3)->EnableWindow(val);
	GetDlgItem(IDC_COLOR_ORDER_OPTION)->EnableWindow(val);
	GetDlgItem(IDC_SORTING_OPTION)->EnableWindow(val);
	GetDlgItem(IDC_SORTING_OPTION_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_ORDER_INFO_DISPLAY)->EnableWindow(val);
}


void TabContent1::enableWindowsOnStrokes(BOOL val) {
	GetDlgItem(IDC_NOISE_AMPLITUDE_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_NOISE_AMPLITUDE)->EnableWindow(val);
	GetDlgItem(IDC_NOISE_AMPLITUDE_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_PARAM1_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_PARAM1)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_PARAM1_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_POSITION_JITTER_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_POSITION_JITTER)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_POSITION_JITTER_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_AMOUNT_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_AMOUNT)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_AMOUNT_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_NUM_LAYERS_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_NUM_LAYERS)->EnableWindow(val);
	GetDlgItem(IDC_NUM_LAYERS_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_AREA_ERROR_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_AREA_ERROR)->EnableWindow(val);
	GetDlgItem(IDC_AREA_ERROR_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_OPACITY_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_OPACITY)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_OPACITY_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_AMBIENT_CAPTION)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_AMBIENT_H)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_AMBIENT_H_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_AMBIENT_S)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_AMBIENT_S_SPIN)->EnableWindow(val);

	GetDlgItem(IDC_STROKE_AMBIENT_V)->EnableWindow(val);
	GetDlgItem(IDC_STROKE_AMBIENT_V_SPIN)->EnableWindow(val);


	if(reinterpret_cast<CButton*>(GetDlgItem(IDC_RENDER_IBFV))->GetCheck() == 1) {
		GetDlgItem(IDC_STROKE_DISPLACEMENT_CAPTION)->EnableWindow(val);
		GetDlgItem(IDC_STROKE_DISPLACEMENT)->EnableWindow(val);
		GetDlgItem(IDC_STROKE_DISPLACEMENT_SPIN)->EnableWindow(val);

		GetDlgItem(IDC_STROKE_MINLENGTH_CAPTION)->EnableWindow(FALSE);
		GetDlgItem(IDC_STROKE_MINLENGTH)->EnableWindow(FALSE);
		GetDlgItem(IDC_STROKE_MINLENGTH_SPIN)->EnableWindow(FALSE);

		GetDlgItem(IDC_STROKE_MAXLENGTH_CAPTION)->EnableWindow(FALSE);
		GetDlgItem(IDC_STROKE_MAXLENGTH)->EnableWindow(FALSE);
		GetDlgItem(IDC_STROKE_MAXLENGTH_SPIN)->EnableWindow(FALSE);
	}
	else if(reinterpret_cast<CButton*>(GetDlgItem(IDC_RENDER_SPLINE))->GetCheck() == 1) {
		GetDlgItem(IDC_STROKE_DISPLACEMENT_CAPTION)->EnableWindow(FALSE);
		GetDlgItem(IDC_STROKE_DISPLACEMENT)->EnableWindow(FALSE);
		GetDlgItem(IDC_STROKE_DISPLACEMENT_SPIN)->EnableWindow(FALSE);

		GetDlgItem(IDC_STROKE_MINLENGTH_CAPTION)->EnableWindow(val);
		GetDlgItem(IDC_STROKE_MINLENGTH)->EnableWindow(val);
		GetDlgItem(IDC_STROKE_MINLENGTH_SPIN)->EnableWindow(val);

		GetDlgItem(IDC_STROKE_MAXLENGTH_CAPTION)->EnableWindow(val);
		GetDlgItem(IDC_STROKE_MAXLENGTH)->EnableWindow(val);
		GetDlgItem(IDC_STROKE_MAXLENGTH_SPIN)->EnableWindow(val);
	}
}


void TabContent1::enableWindowsOnPostProcessing(BOOL val) {
	GetDlgItem(IDC_POST_PROCESSING_OPERATION)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESSING_OPERATION_CAPTION)->EnableWindow(val);

	GetDlgItem(IDC_POST_PROCESS_PARAM1)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM1_SPIN)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM1_CAPTION)->EnableWindow(val);
	
	GetDlgItem(IDC_POST_PROCESS_PARAM2)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM2_SPIN)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM2_CAPTION)->EnableWindow(val);
	
	GetDlgItem(IDC_POST_PROCESS_PARAM3)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM3_SPIN)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM3_CAPTION)->EnableWindow(val);
	
	GetDlgItem(IDC_POST_PROCESS_PARAM4)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM4_SPIN)->EnableWindow(val);
	GetDlgItem(IDC_POST_PROCESS_PARAM4_CAPTION)->EnableWindow(val);

	GetDlgItem(IDC_POST_PROCESSING_SCHEME_CAPTION)->EnableWindow(val);

	switch(reinterpret_cast<CComboBox*>(GetDlgItem(IDC_POST_PROCESSING_OPERATION))->GetCurSel()) {
		case 0:
			GetDlgItem(IDC_EMBOSSING_0)->EnableWindow(FALSE);
			GetDlgItem(IDC_EMBOSSING_1)->EnableWindow(FALSE);
			updatePostProcessingCaptions(0);
			break;

		case 1:
			if(parent->getVisView()->getRenderingMethod() == VisView::IBFV) {
				GetDlgItem(IDC_EMBOSSING_0)->EnableWindow(val);
				GetDlgItem(IDC_EMBOSSING_1)->EnableWindow(val);
			}
			else {
				GetDlgItem(IDC_EMBOSSING_0)->EnableWindow(val);
				GetDlgItem(IDC_EMBOSSING_1)->EnableWindow(val);
			}

			updatePostProcessingCaptions(1);
			break;
	}
}


void TabContent1::enableWindowsOnStyleInterpolation(BOOL val) {
	GetDlgItem(IDC_STYLE_INTERPOLATION_SELECTION_COMBO)->EnableWindow(val);

	updateStyleInterpolationCombo();
}


void TabContent1::updatePostProcessingCaptions(int idx) {
	switch(idx) {
		case 0:
			GetDlgItem(IDC_POST_PROCESS_PARAM1_CAPTION)->SetWindowText(_T("Edge Darkening:"));
			GetDlgItem(IDC_POST_PROCESS_PARAM2_CAPTION)->SetWindowText(_T("Pigment:"));
			GetDlgItem(IDC_POST_PROCESS_PARAM3_CAPTION)->SetWindowText(_T("Turbulance:"));
			GetDlgItem(IDC_POST_PROCESS_PARAM4_CAPTION)->SetWindowText(_T("Paper Texture:"));
			break;

		case 1:
			GetDlgItem(IDC_POST_PROCESS_PARAM1_CAPTION)->SetWindowText(_T("Angle:"));
			GetDlgItem(IDC_POST_PROCESS_PARAM2_CAPTION)->SetWindowText(_T("Height:"));
			GetDlgItem(IDC_POST_PROCESS_PARAM3_CAPTION)->SetWindowText(_T("Brush Jitter:"));
			GetDlgItem(IDC_POST_PROCESS_PARAM4_CAPTION)->SetWindowText(_T("Jitter Freq:"));
			break;
	}
}


void TabContent1::OnCbnSelchangeDisplayMode() {
	bool prev_timer_status;
	CComboBox* cb;

	VisView *visview = parent->getVisView();
	int idx = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_DISPLAY_MODE))->GetCurSel();

	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	switch(idx) {
		case 0:
			// first set the display mode
			visview->setDisplayMode(VisView::VECTOR_EDGE_FIELD);

			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT)), visview->getVisDisplacement(), displacement_prec);
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getVisBlendAlpha());
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getVisIterations());
			reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->SetCurSel((int)visview->getVisColorCompositionMethod());

			cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));

			while(cb->GetCount()) cb->DeleteString(0);
			for(int i = 0; i < num_vec_img_composition_methods; i++) cb->AddString(vec_img_composition_methods[i]);

			cb->SetCurSel(selected_vec_composition_method);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);

			visview->setBackgroundPattern();
			visview->initializeRendering();

			break;

		case 1:
			// first set the display mode
			visview->setDisplayMode(VisView::TENSOR_EDGE_FIELD);

			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT)), visview->getVisDisplacement(), displacement_prec);
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getVisBlendAlpha());
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getVisIterations());
			reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->SetCurSel((int)visview->getVisColorCompositionMethod());

			cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));

			while(cb->GetCount()) cb->DeleteString(0);
			for(int i = 0; i < num_ten_img_composition_methods; i++) cb->AddString(ten_img_composition_methods[i]);

			cb->SetCurSel(selected_ten_composition_method);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);

			visview->setBackgroundPattern();
			visview->initializeRendering();

			break;

		case 2:
			// first set the display mode
			visview->setDisplayMode(VisView::PAINTING);

			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getVisBlendAlpha());
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getVisIterations());
			reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->SetCurSel((int)visview->getVisColorCompositionMethod());

			//visview->updateTexCoordsOnMesh();
			updatePaintingPresetParameters();


			cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));

			while(cb->GetCount()) cb->DeleteString(0);
			for(int i = 0; i < num_ten_img_composition_methods; i++) cb->AddString(ten_img_composition_methods[i]);

			cb->SetCurSel(selected_ten_composition_method);

			enableWindowsOnRenderer(TRUE);
			enableWindowsOnStrokes(TRUE);
			enableWindowsOnLayering(TRUE);
			enableWindowsOnStrokeOrdering(TRUE);
			enableWindowsOnStyleInterpolation(TRUE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(TRUE);
			enableWindowsOnPostProcessing(TRUE);

			visview->initializeRendering();

			break;

		case 3:
			visview->setDisplayMode(VisView::INPUT_IMAGE);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);


			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			break;

		case 4:
			visview->setDisplayMode(VisView::BLACK);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			break;

		case 5:
			visview->setDisplayMode(VisView::BLENDMAP);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			break;

		case 6:
			visview->setDisplayMode(VisView::SEGMENTATION);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			break;

		case 7:
			visview->setDisplayMode(VisView::DATIMAGE);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			break;

		case 8:
			visview->setDisplayMode(VisView::STROKE_REF_IMAGE);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			break;

		default:
			break;
	}


	enableWindowsOnWarpingSetting(idx);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnCbnSelchangeTensorVisMode() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	int idx = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_TENSOR_VIS_MODE))->GetCurSel();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	switch(idx) {
		case 0:
			visview->setTensorVisMode(VisView::MAJOR);
			break;

		case 1:
			visview->setTensorVisMode(VisView::MINOR);
			break;

		case 2:
			visview->setTensorVisMode(VisView::MAJOR_MINOR);
			break;

		default:
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnCbnSelchangeImageCompositionMethod() {
	int idx = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD))->GetCurSel();
	int type = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_DISPLAY_MODE))->GetCurSel();
	bool prev_timer_status;
	VisView *visview = parent->getVisView();


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if(type == 0) {
		selected_vec_composition_method = idx;
	}
	else if(type == 1 || type == 2) {
		selected_ten_composition_method = idx;
	}

	visview->setImageSynthesisMethod(idx);
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnEnKillfocusNumIterations() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION));
	int val = (int)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	switch(visview->getDisplayMode()) {
		case VisView::VECTOR_EDGE_FIELD:
		case VisView::TENSOR_EDGE_FIELD:
			visview->setVisIterations(val);
			val = visview->getVisIterations();
			::setNumberToCEdit(ce, val);
			break;

		case VisView::PAINTING:
			visview->setPaintIterations(val);
			val = visview->getPaintIterations();
			::setNumberToCEdit(ce, val);
			break;

		default:
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposNumIterationsSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (int)::getNumberFromCEdit(ce) + delta);

	OnEnKillfocusNumIterations();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusDisplacement() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT));
	double val = ::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setVisDisplacement(val);

	val = visview->getVisDisplacement();
	::setNumberToCEdit(ce, val, displacement_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposDisplacementSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	double delta = 0.001;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, getNumberFromCEdit(ce) + delta, displacement_prec);

	OnEnKillfocusDisplacement();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusBgImgBlend() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND));
	int val = (int)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	switch(visview->getDisplayMode()) {
		case VisView::VECTOR_EDGE_FIELD:
		case VisView::TENSOR_EDGE_FIELD:
			visview->setVisBlendAlpha(val);
			val = visview->getVisBlendAlpha();
			::setNumberToCEdit(ce, val);
			break;

		case VisView::PAINTING:
			visview->setPaintBlendAlpha(val);
			val = visview->getPaintBlendAlpha();
			::setNumberToCEdit(ce, val);
			break;

		default:
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposBgImgBlendSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (int)::getNumberFromCEdit(ce) + delta);

	OnEnKillfocusBgImgBlend();

	*pResult = 0;
}


void TabContent1::OnCbnSelchangeColorCompositionMethod() {
	int val;
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	val = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->GetCurSel();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();


	switch(visview->getDisplayMode()) {
		case VisView::VECTOR_EDGE_FIELD:
		case VisView::TENSOR_EDGE_FIELD:
			visview->setVisColorCompositionMethod(VisView::ALPHA_BLEND);

			GetDlgItem(IDC_BGIMG_BLEND_CAPTION)->EnableWindow(TRUE);
			GetDlgItem(IDC_BGIMG_BLEND)->EnableWindow(TRUE);
			GetDlgItem(IDC_BGIMG_BLEND_SPIN)->EnableWindow(TRUE);
			break;

		case VisView::PAINTING:

			switch(reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->GetCurSel()) {
				case 0:
					visview->setPaintColorCompositionMethod(VisView::ALPHA_BLEND);

					GetDlgItem(IDC_BGIMG_BLEND_CAPTION)->EnableWindow(TRUE);
					GetDlgItem(IDC_BGIMG_BLEND)->EnableWindow(TRUE);
					GetDlgItem(IDC_BGIMG_BLEND_SPIN)->EnableWindow(TRUE);

					break;

				case 1:
					visview->setPaintColorCompositionMethod(VisView::OVERWRITE);

					GetDlgItem(IDC_BGIMG_BLEND_CAPTION)->EnableWindow(FALSE);
					GetDlgItem(IDC_BGIMG_BLEND)->EnableWindow(FALSE);
					GetDlgItem(IDC_BGIMG_BLEND_SPIN)->EnableWindow(FALSE);

					break;


				default:
					break;
			}

			break;

		default:
			break;
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposNoiseAmplitudeSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_NOISE_AMPLITUDE));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusNoiseAmplitude();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusNoiseAmplitude() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_NOISE_AMPLITUDE));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_color_jitter = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	::setNumberToCEdit(ce, sp.stroke_color_jitter, default_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeParam1Spin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_PARAM1));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusStrokeParam1();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeParam1() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_PARAM1));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_size = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	::setNumberToCEdit(ce, sp.stroke_size, default_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeAmountSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMOUNT));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusStrokeAmount();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeAmount() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMOUNT));


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_gridsize = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	
	sp = visview->getStrokeParams();

	::setNumberToCEdit(ce, sp.stroke_gridsize, default_prec);


	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}



void TabContent1::OnCbnSelchangeNpn() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	int val = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_NPN))->GetCurSel();

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setNPNSize(_ttoi(NPN_type[val]));
	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnEnKillfocusPostProcessParam1() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM1));
	float val = (float)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setPostProcessingParam(0, val);

	::setNumberToCEdit(ce, visview->getPostProcessingParam(0), default_prec);


	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposPostProcessParam1Spin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM1));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);

	OnEnKillfocusPostProcessParam1();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusPostProcessParam2() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM2));
	float val = (float)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setPostProcessingParam(1, val);

	::setNumberToCEdit(ce, visview->getPostProcessingParam(1), default_prec);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposPostProcessParam2Spin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM2));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);

	OnEnKillfocusPostProcessParam2();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusPostProcessParam3() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM3));
	float val = (float)::getNumberFromCEdit(ce);

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setPostProcessingParam(2, val);

	::setNumberToCEdit(ce, visview->getPostProcessingParam(2), default_prec);


	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposPostProcessParam3Spin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM3));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);

	OnEnKillfocusPostProcessParam3();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusPostProcessParam4() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM4));
	float val = (float)::getNumberFromCEdit(ce);

	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setPostProcessingParam(3, val);

	::setNumberToCEdit(ce, visview->getPostProcessingParam(3), default_prec);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposPostProcessParam4Spin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM4));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);

	OnEnKillfocusPostProcessParam4();

	*pResult = 0;
}


void TabContent1::OnCbnSelchangePostProcessingOperation() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	int val = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_POST_PROCESSING_OPERATION))->GetCurSel();


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setPostProcessingOperation(val);

	enableWindowsOnPostProcessing(TRUE);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedPresetWatercolor()
{
	VisView *visview = parent->getVisView();

	visview->stopDisplayTimer();

	loadPaintingPreset(PRESET_WATERCOLOR);

	visview->startDisplayTimer();
}


void TabContent1::OnBnClickedPresetPointillism()
{
	VisView *visview = parent->getVisView();

	visview->stopDisplayTimer();

	loadPaintingPreset(PRESET_POINTILLISM);

	visview->startDisplayTimer();
}


void TabContent1::OnBnClickedPresetVangoghSP()
{
	VisView *visview = parent->getVisView();

	visview->stopDisplayTimer();

	loadPaintingPreset(PRESET_VANGOGH_SP);

	visview->startDisplayTimer();
}


void TabContent1::OnBnClickedPresetImpressionismSP()
{
	VisView *visview = parent->getVisView();

	visview->stopDisplayTimer();

	loadPaintingPreset(PRESET_IMPRESSIONISM_SP);

	visview->startDisplayTimer();
}


void TabContent1::OnBnClickedPresetColorwashSP()
{
	VisView *visview = parent->getVisView();

	visview->stopDisplayTimer();

	loadPaintingPreset(PRESET_COLORWASH_SP);

	visview->startDisplayTimer();
}


void TabContent1::OnBnClickedPresetFracture2()
{
	VisView *visview = parent->getVisView();

	visview->stopDisplayTimer();

	loadPaintingPreset(PRESET_FRACTURE2);

	visview->startDisplayTimer();
}


void TabContent1::OnEnKillfocusStrokePositionJitter() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_POSITION_JITTER));


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_position_jitter = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);

	sp = visview->getStrokeParams();
	::setNumberToCEdit(ce, sp.stroke_position_jitter, default_prec);


	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokePositionJitterSpin(NMHDR *pNMHDR, LRESULT *pResult)
{
	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_POSITION_JITTER));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusStrokePositionJitter();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusGapThreshold() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_GAP_THRESHOLD));
	int val = (int)::getNumberFromCEdit(ce);


	val = (int)::clampVal(val, 0, 255);

	::setNumberToCEdit(ce, val);
	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposGapThresholdSpin(NMHDR *pNMHDR, LRESULT *pResult)
{	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_GAP_THRESHOLD));
	int val = (int)::getNumberFromCEdit(ce);

	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, val + delta);
	OnEnKillfocusGapThreshold();

	*pResult = 0;
}


void TabContent1::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}



void TabContent1::OnEnKillfocusNumLayers() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_NUM_LAYERS));
	int val = (int)::getNumberFromCEdit(ce);


	val = (int)::clampVal(val, 1, visview->getMaxSupportedLayers());

	::setNumberToCEdit(ce, val);
	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setNumEnabledLayers(val);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposNumLayersSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_NUM_LAYERS));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (int)::getNumberFromCEdit(ce) + delta);
	OnEnKillfocusNumLayers();

	*pResult = 0;
}


void TabContent1::OnDeltaposAreaError(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_AREA_ERROR));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (int)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusAreaError();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusAreaError() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_AREA_ERROR));
	float val = (float)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->setAreaErrorThreshold(val);
	visview->initializeRendering();

	::setNumberToCEdit(ce, visview->getAreaErrorThreshold(), default_prec);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::updatePaintingPresetParameters() {
	StrokeParams sp;
	CComboBox *ccb;
	CButton *cb;
	VisView *visview = parent->getVisView();


	ccb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD));
	ccb->SetCurSel((int)::clampVal(((visview->getPaintColorCompositionMethod() == VisView::ALPHA_BLEND) ? 0 : 1), 0, ccb->GetCount() - 1));

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getPaintBlendAlpha());
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getPaintIterations());


	enableWindowsOnRenderer(TRUE);


	sp = visview->getStrokeParams();
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_NOISE_AMPLITUDE)), sp.stroke_color_jitter, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_DISPLACEMENT)), sp.stroke_displacemnt, displacement_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_PARAM1)), sp.stroke_size, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMOUNT)), sp.stroke_gridsize, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_POSITION_JITTER)), sp.stroke_position_jitter, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_OPACITY)), sp.stroke_opacity, default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MINLENGTH)), sp.stroke_min_length);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MAXLENGTH)), sp.stroke_max_length);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_H)), sp.stroke_color_shift[0], default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_S)), sp.stroke_color_shift[1], hsv_sv_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_V)), sp.stroke_color_shift[2], hsv_sv_prec);
	enableWindowsOnStrokes(TRUE);

	enableWindowsOnStyleInterpolation(TRUE);
	enableWindowsOnStrokeOrdering(TRUE);

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_NUM_LAYERS)), visview->getNumEnabledLayers());
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_AREA_ERROR)), visview->getAreaErrorThreshold(), default_prec);
	enableWindowsOnLayering(TRUE);


	ccb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_POST_PROCESSING_OPERATION));
	ccb->SetCurSel((int)::clampVal(visview->getPostProcessingOperation(), 0, ccb->GetCount() - 1));

	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM1)), visview->getPostProcessingParam(0), default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM2)), visview->getPostProcessingParam(1), default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM3)), visview->getPostProcessingParam(2), default_prec);
	::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM4)), visview->getPostProcessingParam(3), default_prec);


	cb = reinterpret_cast<CButton*>(GetDlgItem(IDC_ENABLE_POST_PROCESSING));
	cb->EnableWindow(TRUE);

	enableWindowsOnPostProcessing(cb->GetCheck() == 1 ? TRUE : FALSE);


	reinterpret_cast<CComboBox*>(GetDlgItem(IDC_DISPLAY_MODE))->SetCurSel(2);
	enableWindowsOnWarpingSetting(2);


	updateStyleInterpolationCombo();
}


void TabContent1::loadPaintingPreset(const PaintingPreset &preset) {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	prev_timer_status = visview->getDisplayTimerStatus();
	
	visview->stopDisplayTimer();

	visview->setKey(preset);
	visview->setDisplayMode(VisView::PAINTING);
	visview->initializeRendering();

	updatePaintingPresetParameters();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnEnKillfocusStrokeOpacity() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_OPACITY));


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_opacity = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);

	sp = visview->getStrokeParams();
	::setNumberToCEdit(ce, sp.stroke_opacity, default_prec);


	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeOpacitySpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_OPACITY));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusStrokeOpacity();

	*pResult = 0;
}


void TabContent1::OnBnClickedResetPainting() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->resetPaintingRegions();
	visview->initializeRendering();

	updatePaintingPresetParameters();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedSelectTraceMode() {
	const int num_traces = 4;
	VisView *visview = parent->getVisView();
	CButton *buttons[num_traces];
	PathMaker::MODE mode[num_traces];

	buttons[0] = reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_FREEFORM));
	buttons[1] = reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_CIRCLE));
	buttons[2] = reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_SQUARE));
	buttons[3] = reinterpret_cast<CButton*>(GetDlgItem(IDC_TRACE_LINE));

	mode[0] = PathMaker::FREEFORM;
	mode[1] = PathMaker::CIRCLE;
	mode[2] = PathMaker::SQUARE;
	mode[3] = PathMaker::LINE;

	for(int i = 0; i < num_traces; i++)  {
		if(buttons[i]->GetCheck() == 1) {
			visview->setTraceMode(mode[i]);
		}
	}
}


void TabContent1::OnBnClickedShowCurves() {
	VisView *visview = parent->getVisView();
	CButton *cb = reinterpret_cast<CButton*>(GetDlgItem(IDC_SHOW_CURVES));
	bool prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if(cb->GetCheck() == 1) {
		visview->setShowCurves(true);
	}
	else {
		visview->setShowCurves(false);
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedSetPreset() {
	VisView *visview = parent->getVisView();
	PaintingPreset p;
	bool prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();


	p.color_composition_method = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->GetCurSel();
	p.alpha = (int)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)));

	p.displacement = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_DISPLACEMENT)));
	p.jitter_amplitude = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_NOISE_AMPLITUDE)));
	p.stroke_pos_jitter = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_POSITION_JITTER)));
	p.stroke_gridsize = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMOUNT)));
	p.stroke_size = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_PARAM1)));
	p.stroke_initial_opacity = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_OPACITY)));
	p.stroke_min_length = (int)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MINLENGTH)));
	p.stroke_max_length = (int)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MAXLENGTH)));
	p.stroke_color_shift[0] = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_H)));
	p.stroke_color_shift[1] = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_S)));
	p.stroke_color_shift[2] = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_V)));

	p.num_layers = (int)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_NUM_LAYERS)));
	p.area_error = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_AREA_ERROR)));

	p.post_process_operation = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_POST_PROCESSING_OPERATION))->GetCurSel();
	p.post_process_val1 = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM1)));
	p.post_process_val2 = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM2)));
	p.post_process_val3 = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM3)));
	p.post_process_val4 = (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM4)));

	visview->setKey(p);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedRemovePreset() {
	VisView *visview = parent->getVisView();
	bool prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->removeKey();
	visview->initializeRendering();

	updatePaintingPresetParameters();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnEnKillfocusTestEdit() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_TEST_EDIT));
	float val = (float)::getNumberFromCEdit(ce);


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->testparam_f = val;
	::setNumberToCEdit(ce, val, 2);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposTestEditSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	double delta = .01;
	VisView *visview = parent->getVisView();
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_TEST_EDIT));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, 2);
	OnEnKillfocusTestEdit();

	*pResult = 0;
}


void TabContent1::OnDeltaposStrokeMinLengthSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MINLENGTH));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (int)::getNumberFromCEdit(ce) + delta);
	OnEnKillfocusStrokeMinLength();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeMinLength() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MINLENGTH));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_min_length = (int)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	setNumberToCEdit(ce, sp.stroke_min_length);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeMaxLengthSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MAXLENGTH));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (int)::getNumberFromCEdit(ce) + delta);
	OnEnKillfocusStrokeMaxLength();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeMaxLength() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_MAXLENGTH));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_max_length = (int)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	setNumberToCEdit(ce, sp.stroke_max_length);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedEnablePostProcessing() {
	BOOL val;
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CButton *cb = reinterpret_cast<CButton*>(GetDlgItem(IDC_ENABLE_POST_PROCESSING));


	prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();

	if(cb->IsWindowEnabled() == TRUE && cb->GetCheck() == 1) {
		val = TRUE;
	}
	else {
		val = FALSE;
	}

	enableWindowsOnPostProcessing(val);

	if(val == TRUE) {
		visview->enablePostProcessing(true);
		visview->setPostProcessingParam(0, (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM1))));
		visview->setPostProcessingParam(1, (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM2))));
		visview->setPostProcessingParam(2, (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM3))));
		visview->setPostProcessingParam(3, (float)::getNumberFromCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_POST_PROCESS_PARAM4))));
		OnCbnSelchangePostProcessingOperation();
	}
	else {
		visview->enablePostProcessing(false);
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedSelectStrokeOrder() {
	bool prev_timer_status;
	const int num_options = 3;
	VisView *visview = parent->getVisView();
	CButton *buttons[num_options];


	buttons[0] = reinterpret_cast<CButton*>(GetDlgItem(IDC_STROKE_ORDER_1));
	buttons[1] = reinterpret_cast<CButton*>(GetDlgItem(IDC_STROKE_ORDER_2));
	buttons[2] = reinterpret_cast<CButton*>(GetDlgItem(IDC_STROKE_ORDER_3));

	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	for(int i = 0; i < num_options; i++)  {
		if(buttons[i]->GetCheck() == 1) {
			visview->setStrokeOrder(i);

			if(option_dlg != NULL) {
				OnBnClickedColorOrderOption();
			}
			else {
				setStrokeOrderInfoText();		// just replace text
			}

			break;
		}
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedSelectEmbossingType() {
	bool prev_timer_status;
	const int num_options = 2;
	VisView *visview = parent->getVisView();
	CButton *buttons[2];


	buttons[0] = reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_0));
	buttons[1] = reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_1));

	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	for(int i = 0; i < num_options; i++)  {
		if(buttons[i]->GetCheck() == 1) {
			visview->setEmbossingType(i);
		}
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedSelectRenderer() {
	bool prev_timer_status;
	const int num_options = 2;
	int option;
	VisView *visview = parent->getVisView();
	CButton *buttons[num_options];


	buttons[0] = reinterpret_cast<CButton*>(GetDlgItem(IDC_RENDER_IBFV));
	buttons[1] = reinterpret_cast<CButton*>(GetDlgItem(IDC_RENDER_SPLINE));

	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	for(int i = 0; i < num_options; i++)  {
		if(buttons[i]->GetCheck() == 1) {
			visview->setRenderingMethod((VisView::RENDERER)i);
			option = i;
			break;
		}
	}


	if(false) {
		visview->setEmbossingType(1);

		reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_0))->SetCheck(0);
		reinterpret_cast<CButton*>(GetDlgItem(IDC_EMBOSSING_1))->SetCheck(1);
	}


	// change postprocessing enability...
	enableWindowsOnPostProcessing(TRUE);
	enableWindowsOnStrokes(TRUE);


	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeDisplacementSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	double delta = 0.001;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_DISPLACEMENT));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, getNumberFromCEdit(ce) + delta, displacement_prec);
	OnEnKillfocusStrokeDisplacement();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeDisplacement() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_DISPLACEMENT));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_displacemnt = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	::setNumberToCEdit(ce, sp.stroke_displacemnt, displacement_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnBnClickedColorOrderOption() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();

	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	if(option_dlg != NULL) {
		option_dlg->DestroyWindow();
		delete option_dlg;
		option_dlg = NULL;
	}

	switch(visview->getStrokeOrder()) {
		case 1:
			option_dlg = new RGBOptionDlg(visview, this);
			option_dlg->Create(RGBOptionDlg::IDD, this);
			option_dlg->ShowWindow(SW_SHOW);

			break;

		case 2:
			option_dlg = new HSVOptionDlg(visview, this);
			option_dlg->Create(HSVOptionDlg::IDD, this);
			option_dlg->ShowWindow(SW_SHOW);

			break;

		default:
			break;
	}

	setStrokeOrderInfoText();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnCbnSelchangeSortingOption() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	CComboBox *box = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_SORTING_OPTION));

	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	visview->setOrderingRange((box->GetCurSel() == 0) ? true : false);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::setStrokeOrderInfoText() {
	VisView *visview = parent->getVisView();
	bool prev_timer_status = visview->getDisplayTimerStatus();
	int param_idx[4];
	CStatic *info1 = reinterpret_cast<CStatic*>(GetDlgItem(IDC_STROKE_ORDER_INFO_DISPLAY));
	CStatic *info2 = reinterpret_cast<CStatic*>(GetDlgItem(IDC_STROKE_ORDER_INFO_DISPLAY2));
	CString str;


	visview->stopDisplayTimer();

	switch(visview->getStrokeOrder()) {
		case 1:
			for(int i = 0; i < 2; i++) {
				if(RGBOptionDlg::func_type[i].second == StrokeComparator::rgb_comp.getEvalFunc()) {
					str.Format(_T("Function: %s\r\n"), RGBOptionDlg::func_type[i].first);
					info1->SetWindowText(str);
					info2->SetWindowText(_T(""));
					break;
				}
			}

			break;

		case 2:
			for(int i = 0; i < 6; i++) {
				if(HSVOptionDlg::h_func_type[i].second == StrokeComparator::hsv_comp.getEvalFunc_H()) {
					param_idx[0] = i;
					break;
				}
			}

			for(int i = 0; i < 2; i++) {
				if(HSVOptionDlg::s_func_type[i].second == StrokeComparator::hsv_comp.getEvalFunc_S()) {
					param_idx[1] = i;
					break;
				}
			}

			for(int i = 0; i < 2; i++) {
				if(HSVOptionDlg::v_func_type[i].second == StrokeComparator::hsv_comp.getEvalFunc_V()) {
					param_idx[2] = i;
					break;
				}
			}

			for(int i = 0; i < 6; i++) {
				if(HSVOptionDlg::eval_type[i].second == StrokeComparator::hsv_comp.getEvalOrder()) {
					param_idx[3] = i;
					break;
				}
			}

			str.Format(_T("Hue. Function:	%s\r\nSat. Function:	%s\r\nVal. Function:	%s\r\n"), 
				HSVOptionDlg::h_func_type[param_idx[0]].first, 
				HSVOptionDlg::s_func_type[param_idx[1]].first, 
				HSVOptionDlg::v_func_type[param_idx[2]].first
			);

			info1->SetWindowText(str);

			if(param_idx[0] != 0 && param_idx[0] != 1) {
				str.Format(_T("Breakpoint:	%.1f\r\nEval. Order:	%s\r\n"), 
					StrokeComparator::hsv_comp.getHueBreakPoint(), 
					HSVOptionDlg::eval_type[param_idx[3]].first
				);
			}
			else {
				str.Format(_T("Warm Color:	%.1f\r\nEval. Order:	%s\r\n"), 
					StrokeComparator::hsv_comp.getHueBreakPoint(), 
					HSVOptionDlg::eval_type[param_idx[3]].first
				);
			}

			info2->SetWindowText(str);

			break;

		default:
			info1->SetWindowText(_T("No information available\r\n"));
			info2->SetWindowText(_T(""));
			break;
	}

	if(prev_timer_status == true) visview->startDisplayTimer();
}

void TabContent1::OnDeltaposStrokeAmbientHSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_H));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, default_prec);
	OnEnKillfocusStrokeAmbientH();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeAmbientH() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_H));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_color_shift[0] = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	setNumberToCEdit(ce, sp.stroke_color_shift[0], default_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeAmbientSSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_S));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, hsv_sv_prec);
	OnEnKillfocusStrokeAmbientS();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeAmbientS() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_S));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_color_shift[1] = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	setNumberToCEdit(ce, sp.stroke_color_shift[1], hsv_sv_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnDeltaposStrokeAmbientVSpin(NMHDR *pNMHDR, LRESULT *pResult) {
	int delta = 1;
	LPNMUPDOWN pNMUpDown = reinterpret_cast<LPNMUPDOWN>(pNMHDR);
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_V));


	if(pNMUpDown->iDelta > 0) delta *= -1;

	::setNumberToCEdit(ce, (float)::getNumberFromCEdit(ce) + delta, hsv_sv_prec);
	OnEnKillfocusStrokeAmbientV();

	*pResult = 0;
}


void TabContent1::OnEnKillfocusStrokeAmbientV() {
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	StrokeParams sp;
	CEdit* ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_STROKE_AMBIENT_V));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	sp = visview->getStrokeParams();
	sp.stroke_color_shift[2] = (float)::getNumberFromCEdit(ce);

	visview->setStrokeParams(sp);
	sp = visview->getStrokeParams();
	setNumberToCEdit(ce, sp.stroke_color_shift[2], hsv_sv_prec);

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnCbnSelchangeStyleInterpolationSelectionCombo() {
	int current_time;
	bool prev_timer_status;
	VisView *visview = parent->getVisView();
	PaintingRegion *selected_region = NULL;
	TransitionalPaintingPreset::INTERPOLATION_TYPE interpolation_type;
	CComboBox* cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_STYLE_INTERPOLATION_SELECTION_COMBO));


	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	current_time = visview->getCurrentTime();
	selected_region = visview->getSelectedRegion();

	if(selected_region != NULL) {
		switch(cb->GetCurSel()) {
			case 0:
				interpolation_type = TransitionalPaintingPreset::LINEAR;
				break;

			case 1:
				interpolation_type = TransitionalPaintingPreset::SQUARE_ROOT1;
				break;

			case 2:
				interpolation_type = TransitionalPaintingPreset::CUBE_ROOT1;
				break;

			case 3:
				interpolation_type = TransitionalPaintingPreset::SQUARE_ROOT2;
				break;

			case 4:
				interpolation_type = TransitionalPaintingPreset::CUBE_ROOT2;
				break;

			case 5:
				interpolation_type = TransitionalPaintingPreset::EASE;
				break;

			default:
				assert("Interpolation func. selection.");
				break;
		}

		visview->setKeyInterpolationFunc(interpolation_type);
		visview->initializeRendering();
	}


	updatePaintingPresetParameters();

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::updateStyleInterpolationCombo() {
	int current_time;
	VisView *visview = parent->getVisView();
	PaintingRegion *selected_region = NULL;
	TransitionalPaintingPreset::INTERPOLATION_TYPE interpolation_type;
	CComboBox* cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_STYLE_INTERPOLATION_SELECTION_COMBO));


	current_time = visview->getCurrentTime();
	selected_region = visview->getSelectedRegion();

	while(cb->GetCount()) cb->DeleteString(0);

	if(selected_region != NULL && (interpolation_type = visview->getKeyInterpolationFunc()) != TransitionalPaintingPreset::UNDEFINED) {
		for(int i = 1; i < num_style_interpolations; i++) cb->AddString(style_interpolations[i]);
		
		switch(interpolation_type) {
			case TransitionalPaintingPreset::LINEAR:
				cb->SetCurSel(0);
				break;

			case TransitionalPaintingPreset::SQUARE_ROOT1:
				cb->SetCurSel(1);
				break;

			case TransitionalPaintingPreset::CUBE_ROOT1:
				cb->SetCurSel(2);
				break;

			case TransitionalPaintingPreset::SQUARE_ROOT2:
				cb->SetCurSel(3);
				break;

			case TransitionalPaintingPreset::CUBE_ROOT2:
				cb->SetCurSel(4);
				break;

			case TransitionalPaintingPreset::EASE:
				cb->SetCurSel(5);
				break;

			default:
				assert("Interpolation func. selection.");
				break;
		}
	}
	else {
		cb->AddString(style_interpolations[0]);
		cb->SetCurSel(0);
	}

}



void TabContent1::OnShowinput()
{
	// TODO: Add your command handler code here
	CComboBox* cb;
	VisView *visview = parent->getVisView();
	bool prev_timer_status;
	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();
	
	visview->setDisplayMode(VisView::INPUT_IMAGE);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);


			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);

			if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnShowopt()
{
	// TODO: Add your command handler code here
}


void TabContent1::OnShowpainting()
{
	// TODO: Add your command handler code here
		CComboBox* cb;
	VisView *visview = parent->getVisView();
	bool prev_timer_status;
	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	visview->setDisplayMode(VisView::PAINTING);

			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getVisBlendAlpha());
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getVisIterations());
			reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->SetCurSel((int)visview->getVisColorCompositionMethod());

			//visview->updateTexCoordsOnMesh();
			updatePaintingPresetParameters();


			cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));

			while(cb->GetCount()) cb->DeleteString(0);
			for(int i = 0; i < num_ten_img_composition_methods; i++) cb->AddString(ten_img_composition_methods[i]);

			cb->SetCurSel(selected_ten_composition_method);

			enableWindowsOnRenderer(TRUE);
			enableWindowsOnStrokes(TRUE);
			enableWindowsOnLayering(TRUE);
			enableWindowsOnStrokeOrdering(TRUE);
			enableWindowsOnStyleInterpolation(TRUE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(TRUE);
			enableWindowsOnPostProcessing(TRUE);

			visview->initializeRendering();
			if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent1::OnShowseg()
{
	// TODO: Add your command handler code here
		CComboBox* cb;
	VisView *visview = parent->getVisView();
	bool prev_timer_status;
	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();
	
	visview->setDisplayMode(VisView::DATIMAGE);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);
			if(prev_timer_status == true) visview->startDisplayTimer();
		
}


void TabContent1::OnShowtensor()
{
	// TODO: Add your command handler code here
		CComboBox* cb;
	VisView *visview = parent->getVisView();
	bool prev_timer_status;
	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	visview->setDisplayMode(VisView::TENSOR_EDGE_FIELD);

			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT)), visview->getVisDisplacement(), displacement_prec);
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getVisBlendAlpha());
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getVisIterations());
			reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->SetCurSel((int)visview->getVisColorCompositionMethod());

			cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));

			while(cb->GetCount()) cb->DeleteString(0);
			for(int i = 0; i < num_ten_img_composition_methods; i++) cb->AddString(ten_img_composition_methods[i]);

			cb->SetCurSel(selected_ten_composition_method);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);

			visview->setBackgroundPattern();
			visview->initializeRendering();
			if(prev_timer_status == true) visview->startDisplayTimer();


}


void TabContent1::OnShowvec()
{
	// TODO: Add your command handler code here
	CComboBox* cb;
	VisView *visview = parent->getVisView();
	bool prev_timer_status;
	prev_timer_status = visview->getDisplayTimerStatus();
	visview->stopDisplayTimer();

	visview->setDisplayMode(VisView::VECTOR_EDGE_FIELD);

			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DISPLACEMENT)), visview->getVisDisplacement(), displacement_prec);
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_BGIMG_BLEND)), visview->getVisBlendAlpha());
			::setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_WARP_ITERATION)), visview->getVisIterations());
			reinterpret_cast<CComboBox*>(GetDlgItem(IDC_COLOR_COMPOSITION_METHOD))->SetCurSel((int)visview->getVisColorCompositionMethod());

			cb = reinterpret_cast<CComboBox*>(GetDlgItem(IDC_IMAGE_COMPOSITION_METHOD));

			while(cb->GetCount()) cb->DeleteString(0);
			for(int i = 0; i < num_vec_img_composition_methods; i++) cb->AddString(vec_img_composition_methods[i]);

			cb->SetCurSel(selected_vec_composition_method);

			enableWindowsOnRenderer(FALSE);
			enableWindowsOnStrokes(FALSE);
			enableWindowsOnLayering(FALSE);
			enableWindowsOnStrokeOrdering(FALSE);
			enableWindowsOnStyleInterpolation(FALSE);

			GetDlgItem(IDC_ENABLE_POST_PROCESSING)->EnableWindow(FALSE);
			enableWindowsOnPostProcessing(FALSE);

			visview->setBackgroundPattern();
			visview->initializeRendering();
			if(prev_timer_status == true) visview->startDisplayTimer();
}
