#pragma once
#include "stdafx.h"
#include "MFCTEST4.h"
#include "TabContent3.h"
#include "VisView.h"
#include "PathMaker.h"
#include ".\tabcontent3.h"


// TabContent3 dialog

IMPLEMENT_DYNAMIC(TabContent3, CDialog)
TabContent3::TabContent3(CMFCTEST4Dlg* pParent /*=NULL*/)
	: CDialog(TabContent3::IDD, pParent)
{
	ASSERT(pParent != NULL);
	Create(IDD, pParent);
	this->parent = pParent;
	initializeValues();
}


TabContent3::~TabContent3()
{
}


void TabContent3::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}


BEGIN_MESSAGE_MAP(TabContent3, CDialog)
	ON_BN_CLICKED(IDC_START_DIFFUSE, &TabContent3::OnBnClickedStartDiffuse)
	ON_EN_KILLFOCUS(IDC_DIFFUSE_STEPSIZE_ITR, &TabContent3::OnEnKillfocusDiffuseStepsizeItr)
	ON_EN_KILLFOCUS(IDC_DIFFUSE_STEPSIZE, &TabContent3::OnEnKillfocusDiffuseStepsize)
END_MESSAGE_MAP()


void TabContent3::OnOK() {}
void TabContent3::OnCancel() {}


void TabContent3::initializeValues() {
	setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DIFFUSE_STEPSIZE)), parent->getVisView()->dt, 2);
	setNumberToCEdit(reinterpret_cast<CEdit*>(GetDlgItem(IDC_DIFFUSE_STEPSIZE_ITR)), parent->getVisView()->dt_itr);
}



void TabContent3::OnEnKillfocusDiffuseStepsize() {
	VisView *visview = parent->getVisView();
	CEdit *ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DIFFUSE_STEPSIZE));
	bool prev_timer_status = visview->getDisplayTimerStatus();

	visview->stopDisplayTimer();
	visview->dt = ::getNumberFromCEdit(ce);

	::setNumberToCEdit(ce, visview->dt, 2);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent3::OnEnKillfocusDiffuseStepsizeItr() {
	VisView *visview = parent->getVisView();
	CEdit *ce = reinterpret_cast<CEdit*>(GetDlgItem(IDC_DIFFUSE_STEPSIZE_ITR));
	bool prev_timer_status = visview->getDisplayTimerStatus();


	visview->stopDisplayTimer();
	visview->dt_itr = (int)::getNumberFromCEdit(ce);

	if(prev_timer_status == true) visview->startDisplayTimer();
}


void TabContent3::OnBnClickedStartDiffuse() {
	clock_t t1, t2;
	VisView *visview = parent->getVisView();
	CEdit *box = reinterpret_cast<CEdit*>(parent->GetDlgItem(IDC_INFO_BOX));
	CString append;
	bool prev_timer_status = visview->getDisplayTimerStatus();


	visview->stopDisplayTimer();

	t1 = clock();
	visview->updatePaintingStyleField();
	visview->updateTexCoordsOnMesh();
	t2 = clock();	

	if(parent->getPrintStatEnabled() == true) {
		append.Format(_T("Diffusion: %lf\r\n"), (double)(t2 - t1) / CLOCKS_PER_SEC);
		parent->printMessage(append);
	}

	visview->initializeRendering();

	if(prev_timer_status == true) visview->startDisplayTimer();
}
